#include "libwilmaops.h"

#define INT_INV(x, base, max_type) ( (((max_type)1)<<((base)*2)) / (x))
#define INT_DIV(x, y_inv, base, max_type) ( ((x)*(y_inv)+ (((max_type)1<<(base))) ) >> ((base)*2) )

/* ----- Blend Operation ----- */
#define Function CBlend

//#define pixel_op_with_alpha(c) pDestColorValue[c] = (byte)pSrc2ColorValue[c] + INT_DIV(src1Alpha * (pSrc1ColorValue[c] - pSrc2ColorValue[c]), alpha_inv, 16, long long);
//#define pixel_op_without_alpha(c) pDestColorValue[c] = (byte)((int)pSrc2ColorValue[c] * src2Alpha * 255 + src1Alpha * (pSrc1ColorValue[c] * 255 - pSrc2ColorValue[c] * src2Alpha)) / (255 * 255);
//#define pixel_op_without_alpha(c) pDestColorValue[c] = (byte)min(255, ((int)pSrc2ColorValue[c] * src2Alpha * 255 + src1Alpha * (pSrc1ColorValue[c] * 255 - pSrc2ColorValue[c] * src2Alpha)) / (255 * 255) );
//#define pixel_op_with_alpha(c) pDestColorValue[c] = (byte)pSrc2ColorValue[c] + src1Alpha * (pSrc1ColorValue[c] - pSrc2ColorValue[c]) / alpha
#define float_alpha_vars { falpha = (float)src1Alpha / alpha; fcmpl_alpha = 1 - falpha; }
#define pixel_op_with_alpha(c) pDestColorValue[c] = (byte)(pSrc1ColorValue[c] * falpha + pSrc2ColorValue[c] * fcmpl_alpha)
#define pixel_op_without_alpha(c) { int t1, t2, t3; t1 = INT_MULT(pSrc2ColorValue[c], src2Alpha, t2); pDestColorValue[c] = (byte)INT_BLEND(pSrc1ColorValue[c], t1, src1Alpha, t3); }
#define pixel_op_to_opaque(c) pDestColorValue[c] = (byte)INT_BLEND(pSrc1ColorValue[c], pSrc2ColorValue[c], src1Alpha, t)
#define calc_dest_alpha() (int)src2Alpha + src1Alpha - INT_MULT((int)src1Alpha , src2Alpha, t)

#include "composite_impl.c"

#undef Function
#undef pixel_op_with_alpha
#undef pixel_op_without_alpha


